#!/usr/local/bin/perl

use DBI;				# to enable connection to a database
use CGI qw/:standard/;			# uses the standard Perl CGI commands, which includes HTML

require "perl.fns.pl";

$outdoc = new CGI;                   	# creates an instance of CGI, which I can use to create a HTML page

#-------------------------------------------------
# G6DHLL Coursework 4 v4.2 Joanne Carter (jxc04m)
# This page does not validate in XHTML strict.
#-------------------------------------------------

$dblink = connectDB();			# connect to the database

# gets the information passed from the php page and stores it.
$vacancyID = param('vacancyID');
$today = param('date');

# prints the html
print $outdoc-> header('text/html');

printHeader();

print "<h1>Graphical Statistics for Vacancy code: $vacancyID</h1>";

$dblink = connectDB();

#----------------------------
# Will print out stats for all applications including partially completed ones.
#----------------------------
	
$query = "SELECT * FROM Applications WHERE vacancyID = '$vacancyID'";

$sth = $dblink->prepare($query)
	or die "Error. " . $sth->errstr . "\n";
$rv = $sth->execute 
	or die "Error. " . $sth->errstr . "\n";
$numapps = $sth->rows;

# initialist all the values so that the applet has something to work with.
$age60 = 0;
$age50 = 0;
$age40 = 0;
$age30 = 0;
$age20 = 0;
$otherage = 0;
$female = 0;
$male = 0;

if ($numapps == 0)
{
	print "<p>There are not currently any applications for this vacancy.</p>";
}
else
{
	while ($hash_ref = $sth->fetchrow_hashref)
	{
		$applicationID = $hash_ref->{'applicationID'};
		$query = "SELECT * FROM Users WHERE userID='$hash_ref->{'userID'}'";
	
		$sth3 = $dblink->prepare($query)
			or die "Error. " . $sth3->errstr . "\n";
		$rv = $sth3->execute 
			or die "Error. " . $sth3->errstr . "\n";
		$hash_user = $sth3->fetchrow_hashref;
	
		# Split up dob and today into their component parts.  Formatted yyyy-mm-dd.
		@dob = split(/-/, $hash_user->{'dob'});
		@date = split(/-/, $today);
		
		$age = ($date[0] - $dob[0]);
		
		# Age is current year minus year of birth, but if it's not yet month or day of birth then -1.
		if ($dob[1] > $date[1])
		{
			$age--;
		}
		elsif (($dob[1] == $date[1]) && ($dob[2] > $date[2]))
		{
			$age--;
		}

		if ($age > 60) { $age60++; }
		elsif ($age > 50) { $age50++; }
		elsif ($age > 40) { $age40++; }
		elsif ($age > 30) { $age30++; }
		elsif ($age > 20) { $age20++; }
		else { $otherage++; }
		
		# Male or female?
		if ($hash_user->{'gender'} eq "Female") { $female++; }
		else { $male++; }
		
		# This creates a hash with the country as the key.  Every time a new applicant is from that country
		# it adds one to the value (or creates a new key).		
		$country { $hash_user->{'country_origin'} } ++;
	}
	
	# print the applet code
	$number = scalar(keys(%country));
	$counter = 1;


	print "\n<applet code=\"StatsApplet.class\" codebase=\"../java/\" width=\"780\" height=\"550\">\n";
	print "<param name=\"age\" value=\"$otherage,$age20,$age30,$age40,$age50,$age60\" />\n";
	print "<param name=\"gender\" value=\"$female,$male\" />\n";
	
	for $nation (sort keys %country)
	{
		# This goes through the previously created hash, then looks up the country code in the
		# country_list and prints out the country name.
		$cooname .= $country_list{$nation} ;
		if ($counter != $number) { $cooname .= ","; }
		
		$coo .= $country{$nation};
		if ($counter != $number) { $coo .= ","; }
		
		$counter++
	}
	
	print "<param name=\"coo\" value=\"$coo\" />\n";
	print "<param name=\"cooName\" value=\"$cooname\" />\n";
	print "</applet>\n";
}

printEnder();
