#!/usr/local/bin/perl

use CGI qw/:standard/;			# uses the standard Perl CGI commands, which includes HTML
use DBI;				# connects to a database

$outdoc = new CGI; 			

#-------------------------------------------------
# G6DHLL Coursework 4 v4.2 Joanne Carter (jxc04m)
#-------------------------------------------------

# So you can see which country, rather than a confusing country code being printed out. Copied from PHP fns file.
%country_list = ("AF" => "Afghanistan", "AL" => "Albania", "DZ" => "Algeria", "AS" => "American Samoa", 
"AD" => "Andorra", "AO" => "Angola", "AI" => "Anguilla", "AQ" => "Antarctica", "AG" => "Antigua and Barbuda",
"AR" => "Argentina", "AM" => "Armenia", "AW" => "Aruba", "AU" => "Australia", "AT" => "Austria", "AZ" => "Azerbaijan",
"BS" => "Bahamas", "BH" => "Bahrain", "BD" => "Bangladesh", "BB" => "Barbados", "BY" => "Belarus", "BE" => "Belgium",
"BZ" => "Belize", "BJ" => "Benin", "BM" => "Bermuda", "BT" => "Bhutan", "BO" => "Bolivia", "BA" => "Bosnia and Herzegovina",
"BW" => "Botswana", "BV" => "Bouvet Island", "BR" => "Brazil", "IO" => "British Indian Ocean Territory", 
"BN" => "Brunei Darussalam", "BG" => "Bulgaria", "BF" => "Burkina Faso", "BI" => "Burundi", "KH" => "Cambodia",
"CM" => "Cameroon", "CA" => "Canada", "CV" => "Cape Verde", "KY" => "Cayman Islands", "CF" => "Central African Republic",
"TD" => "Chad", "CL" => "Chile", "CN" => "China", "CX" => "Christmas Island", "CC" => "Cocos (Keeling) Islands",
"CO" => "Colombia", "KM" => "Comoros", "CG" => "Congo", "CK" => "Cook Islands", "CR" => "Costa Rica",
"CI" => "Cote D'Ivoire (Ivory Coast)", "HR" => "Croatia (Hrvatska)", "CU" => "Cuba", "CY" => "Cyprus", 
"CZ" => "Czech Republic", "CS" => "Czechoslovakia (former)", "DK" => "Denmark", "DJ" => "Djibouti", "DM" => "Dominica",
"DO" => "Dominican Republic", "TP" => "East Timor", "EC" => "Ecuador", "EG" => "Egypt", "SV" => "El Salvador", 
"GQ" => "Equatorial Guinea", "ER" => "Eritrea", "EE" => "Estonia", "ET" => "Ethiopia", "FK" => "Falkland Islands (Malvinas)",
"FO" => "Faroe Islands", "FJ" => "Fiji", "FI" => "Finland", "FR" => "France", "FX" => "France, Metropolitan",
"GF" => "French Guiana", "PF" => "French Polynesia", "TF" => "French Southern Territories", "GA" => "Gabon", "GM" => "Gambia",
"GE" => "Georgia", "DE" => "Germany", "GH" => "Ghana", "GI" => "Gibraltar", "GR" => "Greece", "GL" => "Greenland",
"GD" => "Grenada", "GP" => "Guadeloupe", "GU" => "Guam", "GT" => "Guatemala", "GN" => "Guinea", "GW" => "Guinea-Bissau",
"GY" => "Guyana", "HT" => "Haiti", "HM" => "Heard and McDonald Islands", "HN" => "Honduras", "HK" => "Hong Kong",
"HU" => "Hungary", "IS" => "Iceland", "IN" => "India", "ID" => "Indonesia", "IR" => "Iran", "IQ" => "Iraq",
"IE" => "Ireland", "IL" => "Israel", "IT" => "Italy", "JM" => "Jamaica", "JP" => "Japan", "JO" => "Jordan",
"KZ" => "Kazakhstan", "KE" => "Kenya", "KI" => "Kiribati", "KP" => "Korea (North)", "KR" => "Korea (South)",
"KW" => "Kuwait", "KG" => "Kyrgyzstan", "LA" => "Laos", "LV" => "Latvia", "LB" => "Lebanon", "LS" => "Lesotho",
"LR" => "Liberia", "LY" => "Libya", "LI" => "Liechtenstein", "LT" => "Lithuania", "LU" => "Luxembourg", "MO" => "Macau",
"MK" => "Macedonia", "MG" => "Madagascar", "MW" => "Malawi", "MY" => "Malaysia", "MV" => "Maldives", "ML" => "Mali",
"MT" => "Malta", "MH" => "Marshall Islands", "MQ" => "Martinique", "MR" => "Mauritania", "MU" => "Mauritius",
"YT" => "Mayotte", "MX" => "Mexico", "FM" => "Micronesia", "MD" => "Moldova", "MC" => "Monaco", "MN" => "Mongolia",
"MS" => "Montserrat", "MA" => "Morocco", "MZ" => "Mozambique", "MM" => "Myanmar", "NA" => "Namibia", "NR" => "Nauru",
"NP" => "Nepal", "NL" => "Netherlands", "AN" => "Netherlands Antilles", "NT" => "Neutral Zone", "NC" => "New Caledonia",
"NZ" => "New Zealand (Aotearoa)", "NI" => "Nicaragua", "NE" => "Niger", "NG" => "Nigeria", "NU" => "Niue", 
"NF" => "Norfolk Island", "MP" => "Northern Mariana Islands", "NO" => "Norway", "OM" => "Oman", "PK" => "Pakistan",
"PW" => "Palau", "PS" => "Palestine", "PA" => "Panama", "PG" => "Papua New Guinea", "PY" => "Paraguay", "PE" => "Peru",
"PH" => "Philippines", "PN" => "Pitcairn", "PL" => "Poland", "PT" => "Portugal", "PR" => "Puerto Rico", "QA" => "Qatar",
"RE" => "Reunion", "RO" => "Romania", "RU" => "Russian Federation", "RW" => "Rwanda", 
"GS" => "S. Georgia and S. Sandwich Isls.", "KN" => "Saint Kitts and Nevis", "LC" => "Saint Lucia", 
"VC" => "Saint Vincent and the Grenadines", "WS" => "Samoa", "SM" => "San Marino", "ST" => "Sao Tome and Principe",
"SA" => "Saudi Arabia", "SN" => "Senegal", "SC" => "Seychelles", "SL" => "Sierra Leone", "SG" => "Singapore",
"SK" => "Slovak Republic", "SI" => "Slovenia", "SB" => "Solomon Islands", "SO" => "Somalia", "ZA" => "South Africa",
"ES" => "Spain", "LK" => "Sri Lanka", "SH" => "St. Helena", "PM" => "St. Pierre and Miquelon", "SD" => "Sudan",
"SR" => "Suriname", "SJ" => "Svalbard and Jan Mayen Islands", "SZ" => "Swaziland", "SE" => "Sweden", "CH" => "Switzerland",
"SY" => "Syria", "TW" => "Taiwan", "TJ" => "Tajikistan", "TZ" => "Tanzania", "TH" => "Thailand", "TG" => "Togo",
"TK" => "Tokelau", "TO" => "Tonga", "TT" => "Trinidad and Tobago", "TN" => "Tunisia", "TR" => "Turkey", "TM" => "Turkmenistan",
"TC" => "Turks and Caicos Islands", "TV" => "Tuvalu", "UM" => "US Minor Outlying Islands", "SU" => "USSR (former)",
"UG" => "Uganda", "UA" => "Ukraine", "AE" => "United Arab Emirates", "UK" => "United Kingdom", "US" => "United States",
"UY" => "Uruguay", "UZ" => "Uzbekistan", "VU" => "Vanuatu", "VA" => "Vatican City State (Holy See)", "VE" => "Venezuela",
"VN" => "Viet Nam", "VG" => "Virgin Islands (British)", "VI" => "Virgin Islands (U.S.)", "WF" => "Wallis and Futuna Islands",
"EH" => "Western Sahara", "YE" => "Yemen", "YU" => "Yugoslavia", "ZR" => "Zaire", "ZM" => "Zambia", "ZW" => "Zimbabwe");

# connect to the database
sub connectDB
{
	$user = "jocarter_admin";
	$password = "ceefer2782";
	$host = "localhost";
	$database = "jocarter_me";

	$dblink = DBI->connect("DBI:mysql:jocarter_me:localhost", $user, $password, {'RaiseError' => 1});
	
	return $dblink;
}

# print the header of the document
sub printHeader
{

print <<html_body;

	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
	<html>

	<head>
	<title>Staff - Perl Scripts</title>
	<link rel="stylesheet" href="../style-staff.css" />
	</head>

	<body>
	<div>
	<div class="top">&nbsp;</div>
	<div class="header">
	<ul>
		<li><a href="../staff/staff.php">Back</a></li>
		<li><a href=# onclick="window.print()">Print Page</a></li>
		</ul>
	</div>
	<div class="main">
	<div class="content">
html_body
}

sub printEnder
{
print <<html_body;
	</div>
	</div>
	</div>
	</body>
	</html>
html_body

}

# to print out the statistics, seemed pointless duplicating the code.
sub printStats
{
	$dblink = connectDB();			# connect to the database
	$vacancyID = @_[0];			# assign variable names to passed parameters.
	$today = @_[1];
	
#----------------------------
# Will print out stats for all applications including partially completed ones.
#----------------------------
	
	$query = "SELECT * FROM Applications WHERE vacancyID = '$vacancyID'";

	$sth = $dblink->prepare($query)
		or die "Error. " . $sth->errstr . "\n";
	$rv = $sth->execute 
		or die "Error. " . $sth->errstr . "\n";
	$numapps = $sth->rows;
	
	print "<p>Number of Applicants: $numapps.</p>";
		
	while ($hash_ref = $sth->fetchrow_hashref)
	{	
		$applicationID = $hash_ref->{'applicationID'};
		$query = "SELECT * FROM Users WHERE userID='$hash_ref->{'userID'}'";
	
		$sth3 = $dblink->prepare($query)
			or die "Error. " . $sth3->errstr . "\n";
		$rv = $sth3->execute 
			or die "Error. " . $sth3->errstr . "\n";
		$hash_user = $sth3->fetchrow_hashref;
	
		# Split up dob and today into their component parts.  Formatted yyyy-mm-dd.
		@dob = split(/-/, $hash_user->{'dob'});
		@date = split(/-/, $today);
		
		$age = ($date[0] - $dob[0]);
		
		# Age is current year minus year of birth, but if it's not yet month or day of birth then -1.
		if ($dob[1] > $date[1])
		{
			$age--;
		}
		elsif (($dob[1] == $date[1]) && ($dob[2] > $date[2]))
		{
			$age--;
		}
		
		$totalage += $age;
		
		# Why elsif?!?!
		if ($age > 60) { $age60++; }
		elsif ($age > 50) { $age50++; }
		elsif ($age > 40) { $age40++; }
		elsif ($age > 30) { $age30++; }
		elsif ($age > 20) { $age20++; }
		else { $otherage++; }
		
		# Male or female?
		if ($hash_user->{'gender'} eq "Female") { $female++; }
		else { $male++; }
		
		# This creates a hash with the country as the key.  Every time a new applicant is from that country
		# it adds one to the value (or creates a new key).		
		$country { $hash_user->{'country_origin'} } ++;
	}
	
	# calculate average age
	$avage = ($totalage / $numapps);
	
	# print the stats
	print "<p><b>Breakdown of applicants by Age:</b></p>";
	print "<table cellpadding=\"3\" cellspacing=\"3\" width=\"50%\">";
	print "<tr><td><b>Age</b></td><td><b>Number of Applicants</b></td></tr>";
	print "<tr><td>Over 60</td><td>$age60</td></tr>";
	print "<tr><td>51 - 60</td><td>$age50</td></tr>";
	print "<tr><td>41 - 50</td><td>$age40</td></tr>";
	print "<tr><td>31 - 40</td><td>$age30</td></tr>";
	print "<tr><td>21 - 30</td><td>$age20</td></tr>";
	print "<tr><td>20 or under</td><td>$otherage</td></tr>";	
	print "</table>";
	print "<p>Average age = " . sprintf('%.02f',$avage) . ".</p>";
	
	print "<p><b>Breakdown of applicants by Gender:</b></p>";
	print "<table cellpadding=\"3\" cellspacing=\"3\" width=\"50%\">";
	print "<tr><td><b>Gender</b></td><td><b>Number of Applicants</b></td></tr>";
	print "<tr><td>Female</td><td>$female</td></tr>";
	print "<tr><td>Male</td><td>$male</td></tr>";
	print "</table>";
	
	print "<p><b>Breakdown of applicants by Country of Origin:</b></p>";
	print "<table cellpadding=\"3\" cellspacing=\"3\" width=\"50%\">";
	print "<tr><td><b>Country</b></td><td><b>Number of Applicants</b></td></tr>";
	
	for $nation (sort keys %country)
	{
		# This goes through the previously created hash, then looks up the country code in the
		# country_list and prints out the country name.
		print "<tr><td>$country_list{$nation}</td><td>$country{$nation}</td></tr>";
	}

	print "</table><br />";
}
