#!/usr/local/bin/perl

use DBI;				# to enable connection to a database
use CGI qw/:standard/;			# uses the standard Perl CGI commands, which includes HTML

require "perl.fns.pl";

$outdoc = new CGI;                   	# creates an instance of CGI, which I can use to create a HTML page

#-------------------------------------------------
# G6DHLL Coursework 4 v4.2 Joanne Carter (jxc04m)
#-------------------------------------------------

$dblink = connectDB();			# connect to the database

# gets the information passed from the php page and stores it
$vacancyID = param('vacancyID');
$today = param('date');

# prints the html
print $outdoc-> header('text/html');

printHeader();

print "<h1>Report for Vacancy code: $vacancyID</h1>";

print "<p>Report generated on $today.</p>";

#---------------------------
# Vacancy information
#---------------------------

print "<h2>Vacancy Details</h2>";

$query = "SELECT * FROM Vacancy WHERE vacancyID='$vacancyID'";

$sth = $dblink->prepare($query)
	or die "Error. " . $sth->errstr . "\n";
$rv = $sth->execute 
	or die "Error. " . $sth->errstr . "\n";
$hash_vac = $sth->fetchrow_hashref;
	
print "<table cellpadding=\"3\" cellspacing=\"3\" width=\"85%\">";
print "<tr><td>Type:</td><td>$hash_vac->{'type'}</td><td>Job title:</td><td>$hash_vac->{'job_title'}</td></tr>";
print "<tr><td>Start date:</td><td>$hash_vac->{'start_date'}</td><td>Duration:</td><td>$hash_vac->{'duration'}</td></tr>";
print "<tr><td>Details:</td><td colspan=\"3\">$hash_vac->{'details'}</td></tr>";
print "<tr><td>Salary:</td><td>$hash_vac->{'salary'}</td>";

# Find out the staff member's name - here it is intentional that the staff and applicant are the same (as both are me!).

$query2 = "SELECT title, firstname, intials, surname, email FROM Users WHERE userID='$hash_vac->{'userID'}'";
$sth2 = $dblink->prepare($query2)
	or die "Error. " . $sth2->errstr . "\n";
$rv2 = $sth2->execute 
	or die "Error. " . $sth2->errstr . "\n";
$hash_vac2 = $sth2->fetchrow_hashref;

print "<td>Staff contact:</td><td><a href=\"mailto:$hash_vac2->{'email'}\">$hash_vac2->{'title'} $hash_vac2->{'firstname'} ";
print "$hash_vac2->{'intials'} $hash_vac2->{'surname'}</a></td></tr>";
print "</table>";

#--------------------------
# Vacancy statistics
#--------------------------

print "<h2>Vacancy Statistics</h2>";

printStats($vacancyID, $today);

print "<p>&nbsp;</p>";

#---------------------------
# Information for each applicant who has applied for the vacancy.
#----------------------------

$query = "SELECT * FROM Applications WHERE vacancyID = '$vacancyID'";

$sth = $dblink->prepare($query)
	or die "Error. " . $sth->errstr . "\n";
$rv = $sth->execute 
	or die "Error. " . $sth->errstr . "\n";
$numapps = $sth->rows;

print "<h1>Applicant Details:</h1>";
print "<p>Number of Applications: $numapps.</p>";

$query = "SELECT * FROM Applications WHERE vacancyID = '$vacancyID' AND status != 'In Progress' AND status != 'Awaiting References'";

$sth = $dblink->prepare($query)
	or die "Error. " . $sth->errstr . "\n";
$rv = $sth->execute 
	or die "Error. " . $sth->errstr . "\n";
$numapps2 = $sth->rows;

print "<p>Number of Completed Applications: $numapps2.</p><br />";

# will only print out details for completed applications, not those in progress or awaiting references.

while ($hash_ref = $sth->fetchrow_hashref)
{
	$applicationID = $hash_ref->{'applicationID'};
	$query = "SELECT * FROM Users WHERE userID='$hash_ref->{'userID'}'";
	
	$sth3 = $dblink->prepare($query)
		or die "Error. " . $sth3->errstr . "\n";
	$rv = $sth3->execute 
		or die "Error. " . $sth3->errstr . "\n";
	$hash_user = $sth3->fetchrow_hashref;
	
	$country = $hash_user->{'country_origin'};
	
	print "<h2>Information about Applicant -> User ID: $hash_user->{'userID'}</h2>";
	print "<table cellpadding=\"3\" cellspacing=\"3\" width=\"85%\">";
	print "<tr><td>Name:</td><td>$hash_user->{'title'} $hash_user->{'firstname'} $hash_user->{'intials'}";
	print " $hash_user->{'surname'}</td><td colspan=\"2\">&nbsp;</td></tr>";
	print "<tr><td>Gender:</td><td>$hash_user->{'gender'}</td><td>DOB (yyyy-mm-dd):</td><td>$hash_user->{'dob'}</td><tr>";
	print "<tr><td>Address:</td><td colspan=\"3\">$hash_user->{'address'} $hash_user->{'postcode'}</td></tr>";
	print "<tr><td>Country of Origin</td><td>$country_list{$country}</td><td>Email:</td>";
	print "<td><a href=\"mailto:$hash_user->{'email'}\">$hash_user->{'email'}</a></td></tr>";
	print "<tr><td>Telephone:</td><td>$hash_user->{'tel'}</td><td>Extension:</td><td>$hash_user->{'ext'}</td></tr>";
	print "<tr><td>Fax:</td><td>$hash_user->{'fax'}</td><td colspan=\"2\">&nbsp;</td></tr>";
	print "</table>";
	
	#-----------------
	# Files uploaded by that applicant.
	#-----------------
	
	$queryf = "SELECT * FROM Files WHERE applicationID='$applicationID'";
	$sthf = $dblink->prepare($queryf)
		or die "Error. " . $sthf->errstr . "\n";
	$rvf = $sthf->execute 
		or die "Error. " . $sthf->errstr . "\n";
	
	print "<p><b>Files uploaded:</b></p>";
	print "<table cellpadding=\"3\" cellspacing=\"3\" width=\"50%\">";
	
	while ($hash_file = $sthf->fetchrow_hashref)
	{
		print "<tr><td>File ($hash_file->{'filetype'}):</td><td>";
		print "<a href=\"../application_files/$hash_file->{'fileID'}_$hash_file->{'filename'}\">";
		print "$hash_file->{'filename'}</td></tr>";	
	}
	
	print "</table>";
	
	#--------------------
	# Reference details
	#--------------------
	
	$queryr = "SELECT * FROM Reference WHERE applicationID='$applicationID'";
	$sthr = $dblink->prepare($queryr)
		or die "Error. " . $sthr->errstr . "\n";
	$rvr = $sthr->execute 
		or die "Error. " . $sthr->errstr . "\n";
	
	print "<p><b>Referees:</b></p>";
	print "<table cellpadding=\"3\" cellspacing=\"3\" width=\"85%\">";
	
	while ($hash_ref = $sthr->fetchrow_hashref)
	{
		$queryr2 = "SELECT * FROM Users WHERE userID='$hash_ref->{'userID'}'";
		$sthr2 = $dblink->prepare($queryr2)
			or die "Error. " . $sthr2->errstr . "\n";
		$rvr2 = $sthr2->execute 
			or die "Error. " . $sthr2->errstr . "\n";
		$hash_ref2 = $sthr2->fetchrow_hashref;
			
		print "<tr><td colspan=\"4\"><u>Referee:</u></td></tr>";
		print "<tr><td>Name:</td><td>$hash_ref2->{'title'} $hash_ref2->{'firstname'} ";
		print "$hash_ref2->{'intials'} $hash_ref2->{'surname'}</td><td>Position:</td><td>$hash_ref2->{'position'}</td></tr>";
		print "<tr><td>Address:</td><td colspan=\"3\">$hash_ref2->{'address'} $hash_ref2->{'postcode'}</td></tr>";
		print "<tr><td>Email:</td><td><a href=\"mailto:$hash_ref2->{'email'}\">$hash_ref2->{'email'}</a></td>";
		print "<td>Fax:</td><td>$hash_ref2->{'fax'}</td></tr>";
		print "<tr><td>Telephone:</td><td>$hash_ref2->{'tel'}</td>";
		print "<td>Extension:</td><td>$hash_ref2->{'ext'}</td></tr>";
	}
	
	print "</table><p>&nbsp;</p>";
}

printEnder();


